package com.rthoni.stssaguenay.business;

import com.luticate.utils.business.LuPromise;
import com.luticate.utils.dbo.LuDataAccessConfigDbo;
import com.rthoni.stssaguenay.dataaccess.SchedulesDataAccess;
import com.rthoni.stssaguenay.dbo.UserFavouriteStopsDbo;
import com.rthoni.stssaguenay.dbo.SchedulesDbo;

import org.joda.time.LocalDateTime;

import java.util.Collections;
import java.util.List;
import java.util.Vector;

/**
 * Created by robin on 10/1/16.
 */

public class SchedulesBusiness {

    public static LuPromise<List<SchedulesDbo>> getMultiple(LuDataAccessConfigDbo config, List<UserFavouriteStopsDbo> favouriteStopDbos, LocalDateTime date, int count)
    {
        return SchedulesDataAccess.getMultiple(config, favouriteStopDbos, date, count);
    }

    public static String getSchedulesString(List<SchedulesDbo> schedulesDbos, String id)
    {
        List<LocalDateTime> schedules = new Vector<>();
        for (SchedulesDbo schedule : schedulesDbos) {
            if (schedule.getStopId().equals(id)) {
                schedules.addAll(schedule.getSchedules());
            }
        }

        Collections.sort(schedules);
        schedules.size();

        StringBuilder text = new StringBuilder();

        for (int i = 0; i < Math.min(5, schedules.size()); ++i) {
            if (i > 0) {
                text.append(", ");
            }
            text.append(schedules.get(i).toString("HH:mm"));
        }
        return text.toString();
    }
}
